unit Video;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, VidGrab, Menus, StdCtrls,ShellAPI;

type
  TForm1 = class(TForm)
    VideoGrabber1: TVideoGrabber;
    PnlRotation: TPanel;
    PnlAR: TPanel;
    RbRotation0: TRadioButton;
    RbRotation90: TRadioButton;
    BtnLoadVideo: TButton;
    CbxMute: TCheckBox;
    CbxLoop: TCheckBox;
    CbxOverlay: TCheckBox;
    EdtOverlay: TEdit;
    RbARTrue: TRadioButton;
    RbARFalse: TRadioButton;
    RbRotation180: TRadioButton;
    RbRotation270: TRadioButton;
    LblFilePath: TLabel;
    OpenDialog1: TOpenDialog;
    LblRotation: TLabel;
    LblAR: TLabel;
    procedure BtnLoadVideoClick(Sender: TObject);
    procedure RbRotation0Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure VideoGrabber1PlayerEndOfStream(Sender: TObject);
    procedure CbxMuteClick(Sender: TObject);
    procedure RbRotation90Click(Sender: TObject);
    procedure RbRotation180Click(Sender: TObject);
    procedure RbRotation270Click(Sender: TObject);
    procedure CbxOverlayClick(Sender: TObject);
    procedure RbARTrueClick(Sender: TObject);
    procedure RbARFalseClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure DropFiles(var msg: TMessage ); message WM_DROPFILES;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.CbxMuteClick(Sender: TObject);
begin
   VideoGrabber1.MuteAudioRendering := CbxMute.Checked;
end;

procedure TForm1.CbxOverlayClick(Sender: TObject);
begin
   VideoGrabber1.TextOverlay_String := EdtOverlay.Text ;
   VideoGrabber1.TextOverlay_Enabled := CbxOverlay.Checked;
end;

procedure TForm1.DropFiles(var msg: TMessage );
var 
  i, count  : integer; 
  dropFileName : array [0..511] of Char; 
  MAXFILENAME: integer; 
begin 
  MAXFILENAME := 511;
  // we check the query for amount of files received 
  count := DragQueryFile(msg.WParam, $FFFFFFFF, dropFileName, MAXFILENAME);
  if count =1 then
  begin
    DragQueryFile(msg.WParam, 0, dropFileName, MAXFILENAME);
    LblFilepath.Caption :=dropFileName;
    VideoGrabber1.PlayerFileName :=dropFileName;
    VideoGrabber1.OpenPlayer;
  end
  else
  begin
    ShowMessage('Drag one video at a time please');
  end;
  // release memory used
  DragFinish(msg.WParam); 
end;

procedure TForm1.BtnLoadVideoClick(Sender: TObject);
var
   OpenDlg: TOpenDialog;
begin
   OpenDlg := TOpenDialog.Create (nil);
   OpenDlg.FileName := '*.avi';

   if OpenDlg.Execute then begin
      LblFilePath.Caption :=OpenDlg.FileName;
      VideoGrabber1.PlayerFileName :=OpenDlg.FileName;
      VideoGrabber1.OpenPlayer;
   end;
   OpenDlg.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 DragAcceptFiles(Handle, True);
end;

procedure TForm1.RbRotation0Click(Sender: TObject);
begin
   VideoGrabber1.VideoProcessing_Rotation := rt_0_deg;
         VideoGrabber1.OpenPlayer;
end;

procedure TForm1.RbRotation90Click(Sender: TObject);
begin
   VideoGrabber1.VideoProcessing_Rotation := rt_90_deg;
         VideoGrabber1.OpenPlayer;
end;

procedure TForm1.RbARTrueClick(Sender: TObject);
begin
VideoGrabber1.Display_AspectRatio := TAspectRatio (ar_box);
end;

procedure TForm1.RbARFalseClick(Sender: TObject);
begin
VideoGrabber1.Display_AspectRatio := TAspectRatio (ar_stretch);
end;

procedure TForm1.RbRotation180Click(Sender: TObject);
begin
   VideoGrabber1.VideoProcessing_Rotation := rt_180_deg;
         VideoGrabber1.OpenPlayer;
end;

procedure TForm1.RbRotation270Click(Sender: TObject);
begin
   VideoGrabber1.VideoProcessing_Rotation := rt_270_deg;
         VideoGrabber1.OpenPlayer;
end;

procedure TForm1.VideoGrabber1PlayerEndOfStream(Sender: TObject);
begin
   if CbxLoop.Checked then
   begin
      CbxLoop.color := clBtnShadow;
      CbxLoop.refresh ;
      VideoGrabber1.RunPlayer;
      sleep(200);
      CbxLoop.color := clBtnFace;
      CbxLoop.refresh ;
       sleep(200);
      CbxLoop.color := clBtnShadow;
      CbxLoop.refresh ;
       sleep(200);
      CbxLoop.color := clBtnFace;
      CbxLoop.refresh ;
   end
   else
      VideoGrabber1.ClosePlayer;
end;

end.
